// -----------------------------------------------------------------------------------------
//
// ManRef.CS                                                          Ulrich Mller 25.05.04
//                                                                    PCS1700       C# Final
// Testrahmen fr die Beispiele der Referenz des Handbuches "ftComputing : FishFa30 fr C#"
//
// -----------------------------------------------------------------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using FishFa30;

namespace ManRef
{
	public class ManRef : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button cmdAction;
		private System.Windows.Forms.Label lblStatus;
	
		// --- FishFace : Klassen-Instanz ----------------------------------------
		// private FishFace  ft = new FishFace(true, false, 0);
		//private FishRobot ft = new FishRobot(new int[,]{{3,222},{4,88}});
		private const int mPlotter = 1;
		private FishStep  ft = new FishStep(new int[,]{{mPlotter,456},{3,456}});

		private System.ComponentModel.Container components = null;

		// --- Konstruktor / Destruktor ------------------------------------------

		public ManRef()
		{
			InitializeComponent();
			ft.PlotChange += new FishStep.PlotDelegate(PositionsAusgabe);
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )	{
			  if (components != null) {
				components.Dispose();
			  }
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.cmdAction = new System.Windows.Forms.Button();
			this.lblStatus = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// cmdAction
			// 
			this.cmdAction.Location = new System.Drawing.Point(40, 80);
			this.cmdAction.Name = "cmdAction";
			this.cmdAction.Size = new System.Drawing.Size(216, 32);
			this.cmdAction.TabIndex = 0;
			this.cmdAction.Text = "&ACTION";
			this.cmdAction.Click += new System.EventHandler(this.cmdAction_Click);
			// 
			// lblStatus
			// 
			this.lblStatus.Font = new System.Drawing.Font("Tahoma", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblStatus.Location = new System.Drawing.Point(16, 16);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(256, 48);
			this.lblStatus.TabIndex = 1;
			this.lblStatus.Text = "Status";
			this.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// ManRef
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 133);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.lblStatus,
																		  this.cmdAction});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "ManRef";
			this.Text = "FishFa30 : C# - Tips & Tricks";
			this.ResumeLayout(false);

		}
		#endregion

		// --- Haupteinstiegspunkt fr die Anwendung -------------------------------

		[STAThread]
		static void Main() 
		{
			Application.Run(new ManRef());
		}

		// --- Zentrale Testroutine -------------------------------------------------

		private void cmdAction_Click(object sender, System.EventArgs e)
		{
			try	
			{
				ft.OpenInterface(Port.COM2);
				lblStatus.Text = "--- fhrt auf Home (linke untere Ecke) ---";
				ft.PlotHome(mPlotter);
				lblStatus.Text = "--- Anfahren 50/50 ----";
				ft.PlotTo(mPlotter, 50, 50);
				lblStatus.Text = "--- Zeichnen eines Quadrats ---";
				Vieleck(new int[,] {{50,0},{0,50},{-50,0},{0,-50}});
				lblStatus.Text = "--- Das war's ---";
			}
			catch(FishFaceException eft) 
			{
				lblStatus.Text = eft.Message;
			}
			finally	
			{
				ft.CloseInterface();
			}
		}
		private void PositionsAusgabe(object sender, int MotNr, int xPos, int yPos)
		{
			lblStatus.Text = "Position X/Y : " + xPos.ToString()+
				" / " + yPos.ToString();
		}
		private void Vieleck(int[,] RelList)
		{
			for(int i = 0; i < RelList.GetLength(0); i++)
				ft.PlotDelta(mPlotter, RelList[i,0], RelList[i,1]);
		}
	}
}
