// -----------------------------------------------------------------------------------------
//
// Riese3.CS                                                          Ulrich Mller 27.05.04
//                                                                    PCS1700       C# Final
// Betriebsprogramm Riesenrad Schritt 3 : Echt-Betrieb
// Basis Assembly FishFa30.DLL / umFish30.DLL
//
// -----------------------------------------------------------------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using FishFa30;

namespace RiesenBetrieb
{
	public class Riese3CS : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button cmdAction;
		private System.Windows.Forms.Label lblStatus;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.NumericUpDown nudFaktor;
	
		// --- Globale Daten ----------------------------------------
		private FishFace ft = new FishFace(true, false, 0);
		const int mRadMotor = (int)Nr.M1, eRadPos = (int)Nr.E2, eQuittung = (int)Nr.E1,
			cLinks = (int)Dir.Links, cRechts = (int)Dir.Rechts, cAus = (int)Dir.Aus;

		private System.ComponentModel.Container components = null;

		// --- Konstruktor / Destruktor ------------------------------------------

		public Riese3CS()
		{
			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )	{
			  if (components != null) {
				components.Dispose();
			  }
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.cmdAction = new System.Windows.Forms.Button();
			this.lblStatus = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.nudFaktor = new System.Windows.Forms.NumericUpDown();
			((System.ComponentModel.ISupportInitialize)(this.nudFaktor)).BeginInit();
			this.SuspendLayout();
			// 
			// cmdAction
			// 
			this.cmdAction.Location = new System.Drawing.Point(40, 104);
			this.cmdAction.Name = "cmdAction";
			this.cmdAction.Size = new System.Drawing.Size(216, 32);
			this.cmdAction.TabIndex = 0;
			this.cmdAction.Text = "&ACTION";
			this.cmdAction.Click += new System.EventHandler(this.cmdAction_Click);
			// 
			// lblStatus
			// 
			this.lblStatus.Font = new System.Drawing.Font("Tahoma", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblStatus.Location = new System.Drawing.Point(16, 16);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(256, 24);
			this.lblStatus.TabIndex = 1;
			this.lblStatus.Text = "Status";
			this.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(112, 72);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(136, 16);
			this.label1.TabIndex = 2;
			this.label1.Text = "Zeitfaktor Runden";
			// 
			// nudFaktor
			// 
			this.nudFaktor.Location = new System.Drawing.Point(40, 72);
			this.nudFaktor.Minimum = new System.Decimal(new int[] {
																	  1,
																	  0,
																	  0,
																	  0});
			this.nudFaktor.Name = "nudFaktor";
			this.nudFaktor.Size = new System.Drawing.Size(64, 20);
			this.nudFaktor.TabIndex = 3;
			this.nudFaktor.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.nudFaktor.Value = new System.Decimal(new int[] {
																	10,
																	0,
																	0,
																	0});
			// 
			// Riese2CS
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 159);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.nudFaktor,
																		  this.label1,
																		  this.lblStatus,
																		  this.cmdAction});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "Riese2CS";
			this.Text = "Riesenrad Schritt 3";
			((System.ComponentModel.ISupportInitialize)(this.nudFaktor)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		// --- Haupteinstiegspunkt fr die Anwendung -------------------------------

		[STAThread]
		static void Main() 
		{
			Application.Run(new Riese3CS());
		}

		// --- Zentrale Betriebsroutine -------------------------------------------------

		private void cmdAction_Click(object sender, System.EventArgs e)
		{
			try	
			{
				ft.OpenInterface(Port.COM2);
				while (!ft.Finish(eQuittung)) {
					lblStatus.Text = "--- Aus- und Einsteigen ---";
					for(int i = 1; i <= 6; i++) {
						ft.SetMotor(mRadMotor, cLinks);
						ft.WaitForHigh(eRadPos);
						ft.Pause(1500);
						ft.SetMotor(mRadMotor, cAus);
						lblStatus.Text = "Gondel : " + i.ToString();
						ft.WaitForLow(eQuittung);
					}
					lblStatus.Text = "Fahrbetrieb : Quittungs-Taster";
					ft.Pause(3000);
					if (!ft.GetInput(eQuittung)) ft.NotHalt = true;
					lblStatus.Text = "--- Tour linksrum ---";
					ft.SetMotor(Nr.M1, Dir.Links);
					ft.Pause(1000 * (int)nudFaktor.Value);
					ft.SetMotor(Nr.M1, Dir.Aus);
					ft.Pause(1000);
					lblStatus.Text = "--- Tour rechtsrum ---";
					ft.SetMotor(Nr.M1, Dir.Rechts);
					ft.Pause(1000 * (int)nudFaktor.Value);
					ft.SetMotor(Nr.M1, Dir.Aus);
					ft.Pause(1000);
               }
				lblStatus.Text = "--- Betrieb beendet ---";
			}
			catch(FishFaceException eft) 
			{
				lblStatus.Text = eft.Message;
			}
			finally	
			{
				ft.CloseInterface();
			}
		}
	}
}
