// -----------------------------------------------------------------------------------------
//
// Riese6.CS                                                          Ulrich Mller 27.05.04
//                                                                    PCS1700       C# Final
// Betriebsprogramm Riesenrad Schritt 6 : Echt-Betrieb - Abbruchsperre, Serialisierung
// Basis Assembly FishFa30.DLL / umFish30.DLL
//
// -----------------------------------------------------------------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using FishFa30;

namespace RiesenBetrieb
{
	public class Riese6CS : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button cmdAction;
		private System.Windows.Forms.Label lblStatus;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.NumericUpDown nudRunden;
		private System.Windows.Forms.Button cmdEnde;
		private System.Windows.Forms.ComboBox cboPortName;
		private System.Windows.Forms.Label label2;
	
		private System.ComponentModel.Container components = null;

		// --- Globale Daten ----------------------------------------
		private FishFace ft = new FishFace(true, false, 0);
		const int mRadMotor = (int)Nr.M1, eRadPos = (int)Nr.E2, eQuittung = (int)Nr.E1,
			cLinks = (int)Dir.Links, cRechts = (int)Dir.Rechts, cAus = (int)Dir.Aus;

		private string IniName = new System.IO.DirectoryInfo(@".\").FullName + 
                             "Riese6CS.DAT";
		private PersDaten gp;


		// --- Konstruktor / Destruktor ------------------------------------------

		public Riese6CS()
		{
			InitializeComponent();
			cboPortName.SelectedIndex = 2;
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )	{
			  if (components != null) {
				components.Dispose();
			  }
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Riese6CS));
			this.cmdAction = new System.Windows.Forms.Button();
			this.lblStatus = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.nudRunden = new System.Windows.Forms.NumericUpDown();
			this.cmdEnde = new System.Windows.Forms.Button();
			this.cboPortName = new System.Windows.Forms.ComboBox();
			this.label2 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.nudRunden)).BeginInit();
			this.SuspendLayout();
			// 
			// cmdAction
			// 
			this.cmdAction.AccessibleDescription = "";
			this.cmdAction.Location = new System.Drawing.Point(32, 304);
			this.cmdAction.Name = "cmdAction";
			this.cmdAction.Size = new System.Drawing.Size(216, 32);
			this.cmdAction.TabIndex = 0;
			this.cmdAction.Text = "&START";
			this.cmdAction.Click += new System.EventHandler(this.cmdAction_Click);
			// 
			// lblStatus
			// 
			this.lblStatus.BackColor = System.Drawing.Color.Transparent;
			this.lblStatus.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblStatus.Font = new System.Drawing.Font("Tahoma", 11.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblStatus.Location = new System.Drawing.Point(8, 64);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(256, 24);
			this.lblStatus.TabIndex = 1;
			this.lblStatus.Text = "Status";
			this.lblStatus.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label1
			// 
			this.label1.BackColor = System.Drawing.Color.Transparent;
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(112, 264);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(136, 16);
			this.label1.TabIndex = 2;
			this.label1.Text = "Anzahl Runden";
			// 
			// nudRunden
			// 
			this.nudRunden.Location = new System.Drawing.Point(40, 264);
			this.nudRunden.Minimum = new System.Decimal(new int[] {
																	  1,
																	  0,
																	  0,
																	  0});
			this.nudRunden.Name = "nudRunden";
			this.nudRunden.Size = new System.Drawing.Size(56, 20);
			this.nudRunden.TabIndex = 3;
			this.nudRunden.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.nudRunden.Value = new System.Decimal(new int[] {
																	5,
																	0,
																	0,
																	0});
			// 
			// cmdEnde
			// 
			this.cmdEnde.AccessibleDescription = "";
			this.cmdEnde.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cmdEnde.Location = new System.Drawing.Point(32, 184);
			this.cmdEnde.Name = "cmdEnde";
			this.cmdEnde.Size = new System.Drawing.Size(216, 32);
			this.cmdEnde.TabIndex = 4;
			this.cmdEnde.Text = "A&bbrechen";
			this.cmdEnde.Click += new System.EventHandler(this.cmdEnde_Click);
			// 
			// cboPortName
			// 
			this.cboPortName.AllowDrop = true;
			this.cboPortName.Items.AddRange(new object[] {
															 "LPT",
															 "COM1",
															 "COM2",
															 "COM3",
															 "COM4"});
			this.cboPortName.Location = new System.Drawing.Point(40, 232);
			this.cboPortName.Name = "cboPortName";
			this.cboPortName.Size = new System.Drawing.Size(64, 21);
			this.cboPortName.TabIndex = 5;
			this.cboPortName.Text = "comboBox1";
			// 
			// label2
			// 
			this.label2.BackColor = System.Drawing.Color.Transparent;
			this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label2.Location = new System.Drawing.Point(112, 232);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(120, 16);
			this.label2.TabIndex = 6;
			this.label2.Text = "Interface Anschlu";
			// 
			// Riese6CS
			// 
			this.AcceptButton = this.cmdAction;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackgroundImage = ((System.Drawing.Bitmap)(resources.GetObject("$this.BackgroundImage")));
			this.CancelButton = this.cmdEnde;
			this.ClientSize = new System.Drawing.Size(274, 359);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label2,
																		  this.cboPortName,
																		  this.cmdEnde,
																		  this.nudRunden,
																		  this.label1,
																		  this.lblStatus,
																		  this.cmdAction});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "Riese6CS";
			this.Text = "Riesenrad Schritt 6";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.Riese6CS_Closing);
			this.Load += new System.EventHandler(this.Riese6CS_Load);
			((System.ComponentModel.ISupportInitialize)(this.nudRunden)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		// --- Haupteinstiegspunkt fr die Anwendung -------------------------------

		[STAThread]
		static void Main() 
		{
			Application.Run(new Riese6CS());
		}


		// --- Zentrale Betriebsroutine -------------------------------------------------

		private void cmdAction_Click(object sender, System.EventArgs e)
		{
			try	
			{
				ft.OpenInterface(cboPortName.SelectedIndex);
				cmdAction.Enabled = false;
				cmdEnde.Text = "&HALT";
				cmdEnde.Focus();
				while (!ft.Finish(Nr.E1)) {
					lblStatus.Text = "--- Aus- und Einsteigen ---";
					for(int i = 1; i <= 3; i++) {
						Beladen(1, i * 2 -1);
						Beladen(3, i * 2);
					}
					lblStatus.Text = "Fahrbetrieb : Quittungs-Taster";
					ft.Pause(3000);
					if (!ft.GetInput(eQuittung)) ft.NotHalt = true;
					ft.SetMotor(Nr.M1, Dir.Links);
					for(int i = 1; i <= (int)nudRunden.Value; i++) {
						lblStatus.Text = "--- Runde : " + i.ToString() + " linksrum ---";
						ft.WaitForChange(eRadPos, 12);
					}
					ft.SetMotor(mRadMotor, cAus);
					ft.Pause(1000);
					ft.SetMotor(mRadMotor, cRechts);
					for(int i = 1; i <= (int)nudRunden.Value; i++) {
						lblStatus.Text = "--- Runde : " + i.ToString() + " rechtsrum ---";
						ft.WaitForChange(eRadPos, 12);
					}
					ft.SetMotor(mRadMotor, cAus);
					ft.Pause(1000);
				}
				lblStatus.Text = "--- Betrieb beendet ---";
			}
			catch(FishFaceException eft) 
			{
				lblStatus.Text = eft.Message;
			}
			finally	
			{
				ft.CloseInterface();
				cmdEnde.Text      = "&ENDE";
				cmdAction.Enabled = true;
			}
		}

		// --- Beladen : Beladen einer Gondel ------------------------------
		private void Beladen(int Position, int Runde) {
			ft.SetMotor(mRadMotor, cLinks);
			for(int n = 1; n <= Position; n++) ft.WaitForHigh(eRadPos);
			ft.Pause(1500);
			ft.SetMotor(mRadMotor, cAus);
			lblStatus.Text = "Gondel : " + Runde.ToString();
			ft.WaitForLow(eQuittung);
		}

		// ---  cmdEnde_Click : Ende, wenn Button-Text = HALT --------------
		private void cmdEnde_Click(object sender, System.EventArgs e)
		{
			if(cmdEnde.Text == "&HALT") ft.NotHalt = true; else this.Close();
		}

		// --- Riese6CS_Closing : Prfen, ob Beenden ber x rechts oben zulssig ist ----
		//                        wenn ja, Serialisieren der persistenten Daten
		private void Riese6CS_Closing(object sender, 
			System.ComponentModel.CancelEventArgs e)
		{
			if(cmdEnde.Text == "&HALT") e.Cancel=true;
			else 
			{
				System.Runtime.Serialization.Formatters.Binary.BinaryFormatter ser = 
					new System.Runtime.Serialization.Formatters.Binary.BinaryFormatter();
				System.IO.FileStream bin = 
					new System.IO.FileStream(IniName, System.IO.FileMode.Create);
				gp.FormLeft = this.Left;
				gp.FormTop  = this.Top;
				gp.PortNr   = cboPortName.SelectedIndex;
				ser.Serialize(bin, gp);
				bin.Close();
			}
		}

		// --- Riese6CS_Load : Deserialisieren der perstenten Daten, 
		//                     bzw. Aufsetzen Default-Werte ----
		private void Riese6CS_Load(object sender, System.EventArgs e)
		{
			if(System.IO.File.Exists(IniName))
			{
				System.Runtime.Serialization.Formatters.Binary.BinaryFormatter ser = 
					new System.Runtime.Serialization.Formatters.Binary.BinaryFormatter();
				System.IO.FileStream bin = 
					new System.IO.FileStream(IniName, System.IO.FileMode.Open);
				gp = (PersDaten)ser.Deserialize(bin);
				bin.Close();
			}
			else gp = new PersDaten();
			this.Left = gp.FormLeft;
			this.Top  = gp.FormTop;
			cboPortName.SelectedIndex = gp.PortNr;
		}
	}
	[Serializable()]
	public class PersDaten 
	{
		public int FormLeft = 0;
		public int FormTop = 0;
		public int PortNr = 2;
	}
}
